# If you want only the aop framework to be built, give rpmbuild option '--with frameworkonly'
%define with_frameworkonly %{?_with_frameworkonly:1}%{!?_with_frameworkonly:0}
%define without_frameworkonly %{!?_with_frameworkonly:1}%{?_with_frameworkonly:0}

%define section  devel
%define shver    1.3
%define name     jboss-aop

Summary:        JBoss AOP Framework
Name:           %{name}
Version:        1.3.0
Release:        2jpp
Epoch:          0
License:        LGPL
Group:          Internet/WWW/Servers
Vendor:         JPackage Project
Distribution:   JPackage
URL:            http://www.jboss.org/
Source0:        jboss-aop_1.3.zip
Source1:	jboss-aop-buildmagic-autoload.properties
Source2:	jboss-aop-buildmagic-buildmagic.ent
Source3:	jboss-aop-framework-build.xml
Source4:	jboss-aop-buildmagic-common.properties
Source5:	jboss-aop-buildmagic-common.xml
Source6:	jboss-aop-buildmagic-libraries.ent
Source7:	jboss-aop-buildmagic-modules.ent
Source8:	jboss-aop-buildmagic-targets.ent
Source9:	jboss-aop-buildmagic-task.properties
Source10:	jboss-aop-etc-default.mf
Source11:	jboss-aspect-library-build.xml
Source12:	jboss-aop_1_0.dtd
Source13:	jboss-aspect-library-RemotingToAOPServerInterceptor.xml
Patch0:		jboss-aop-AspectManager.patch
Patch1:		jboss-aop-AOPClassPool.patch
Patch2:		jboss-aop-scripts.patch
Patch3:		jboss-aop-AnnotationDocletTagFactory.patch

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root
BuildArch:      noarch
# general requires
BuildRequires:  jpackage-utils >= 0:1.6
BuildRequires:       ant >= 0:1.6.2
BuildRequires:       ant-javamail, ant-junit, ant-nodeps, ant-trax
BuildRequires:       bsf
BuildRequires:       jboss4-buildmagic-tasks
BuildRequires:       junit
BuildRequires:       xalan-j2
BuildRequires:       xerces-j2
BuildRequires:       xml-commons-apis
BuildRequires:       xml-commons-resolver
BuildRequires:       java-1.5.0-devel
# framework requires
BuildRequires:       bsh
BuildRequires:       concurrent
BuildRequires:       gnu.trove
BuildRequires:       javassist
BuildRequires:       jboss4-common
BuildRequires:       qdox >= 0:1.5
# library requires
%if %{without_frameworkonly}
BuildRequires:       jboss4-jmx
BuildRequires:       jboss4-system
BuildRequires:       jboss4-deployment
BuildRequires:       jboss4-j2ee
BuildRequires:       jboss4-transaction
BuildRequires:       jboss4-cluster
BuildRequires:       jboss4-remoting
BuildRequires:       jboss4-security
%endif

%description
JBoss AOP is a 100% Pure Java aspected oriented framework 
usuable in any programming environment or tightly integrated 
with our application server. Aspects allow you to more easily 
modularize your code base when regular object oriented 
programming just doesn't fit the bill. It can provide a 
cleaner separation from application logic and system code. 
It provides a great way to expose integration points into 
your software. Combined with JDK 1.5 Annotations, it also 
is a great way to expand the Java language in a clean 
pluggable way rather than using annotations solely for 
code generation. 
JBoss AOP is not only a framework, but also a prepackaged 
set of aspects that are applied via annotations, pointcut 
expressions, or dynamically at runtime. Some of these 
include caching, asynchronous communication, transactions, 
security, remoting, and many many more. 


%package        framework
Summary:        Aspect framework for %{name}
Group:          Development/Libraries
Requires:       bsh
Requires:       concurrent
Requires:       gnu.trove
Requires:       javassist
Requires:       jboss4-common
Requires:       qdox >= 0:1.5

%description    framework
%{summary}.

%if %{without_frameworkonly}
%package        library
Summary:        Aspect library for %{name}
Group:          Development/Libraries
Requires:       bsh
Requires:       concurrent
Requires:       gnu.trove
Requires:       javassist
Requires:       jboss4-common
Requires:       jboss4-cluster
Requires:       jboss4-deployment
Requires:       jboss4-j2ee
Requires:       jboss4-jmx
Requires:       jboss4-remoting
Requires:       jboss4-security
Requires:       jboss4-system
Requires:       jboss4-transaction
Requires:       qdox >= 0:1.5

%description    library
%{summary}.

%package        javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
BuildRequires:  java-javadoc

%description    javadoc
%{summary}.

%package        manual
Summary:        Documents for %{name}
Group:          Development/Documentation

%description    manual
%{summary}.
%endif

%prep
cat <<EOT

                If you want only the aspect framework to be built,
                give rpmbuild option '--with frameworkonly'

EOT
%setup -qq -n jboss-aop_%{shver}
for f in $(find . -name "*.jar"); do
	mv $f $f.no
done
mkdir -p tools/lib
pushd tools/lib
ln -sf $(build-classpath ant) ant.jar
ln -sf $(build-classpath ant/ant-javamail) ant-javamail.jar
ln -sf $(build-classpath ant/ant-junit) ant-junit.jar
ln -sf $(build-classpath ant-launcher) ant-launcher.jar
ln -sf $(build-classpath ant/ant-nodeps) ant-nodeps.jar
ln -sf $(build-classpath ant/ant-trax) ant-trax.jar
ln -sf $(build-classpath bsf) bsf.jar
ln -sf $(build-classpath jboss4/jboss4-buildmagic-tasks) buildmagic-tasks.jar
ln -sf $(build-classpath junit) junit.jar
ln -sf $(build-classpath xml-commons-resolver) resolver.jar
ln -sf $(build-classpath xalan-j2) xalan.jar
ln -sf $(build-classpath xerces-j2) xercesImpl.jar
ln -sf $(build-classpath xml-commons-apis) xml-apis.jar
popd
mkdir -p common/output/lib
pushd common/output/lib
ln -sf $(build-classpath jboss4/jboss-common) jboss-common.jar
popd
mkdir -p tools/etc/buildmagic
cp %{SOURCE1} tools/etc/buildmagic/autoload.properties
cp %{SOURCE2} tools/etc/buildmagic/buildmagic.ent
cp %{SOURCE3} build.xml
cp %{SOURCE4} tools/etc/buildmagic/common.properties
cp %{SOURCE5} tools/etc/buildmagic/common.xml
cp %{SOURCE6} tools/etc/buildmagic/libraries.ent
cp %{SOURCE7} tools/etc/buildmagic/modules.ent
cp %{SOURCE8} tools/etc/buildmagic/targets.ent
cp %{SOURCE9} tools/etc/buildmagic/task.properties
cp %{SOURCE10} etc/default.mf
cp %{SOURCE11} aspect-library-build.xml
cp %{SOURCE12} etc/jboss-aop_1_0.dtd
mkdir -p etc/org/jboss/aspects/remoting
cp %{SOURCE13} etc/org/jboss/aspects/remoting/RemotingToAOPServerInterceptor.xml

%patch0 -b .sav
%patch1 -b .sav
%patch2 -b .sav
%patch3 -b .sav

# -----------------------------------------------------------------------------

%build

BUILD_ID=`date -u +%Y%m%d%H%M`_%{version}-%{release}

export JAVA_HOME=/usr/lib/jvm/java-1.5.0
export CLASSPATH=""

%if %{without_frameworkonly}
ant all
%else
ant most
%endif


mv output output-framework

%if %{without_frameworkonly}

mkdir -p aop/output/lib
cp output-framework/lib/jboss-aop.jar aop/output/lib/jboss-aop.jar
mkdir -p cluster/output/lib
pushd cluster/output/lib
ln  -sf /usr/share/java/jboss4/jbossha.jar .
popd
mkdir -p common/output/lib
pushd common/output/lib
ln  -sf /usr/share/java/jboss4/jboss-common.jar .
popd
mkdir -p deployment/output/lib
pushd deployment/output/lib
ln  -sf /usr/share/java/jboss4/jboss-deployment.jar .
popd
mkdir -p j2ee/output/lib
pushd j2ee/output/lib
ln  -sf /usr/share/java/jboss4/jboss-j2ee.jar .
popd
mkdir -p jmx/output/lib
pushd jmx/output/lib
ln  -sf /usr/share/java/jboss4/jboss-jmx.jar .
popd
mkdir -p remoting/output/lib
pushd remoting/output/lib
ln  -sf /usr/share/java/jboss4/jboss-remoting.jar .
popd
mkdir -p security/output/lib
pushd security/output/lib
ln  -sf /usr/share/java/jboss4/jbosssx.jar .
popd
mkdir -p system/output/lib
pushd system/output/lib
ln  -sf /usr/share/java/jboss4/jboss-system.jar .
popd
mkdir -p transaction/output/lib
pushd transaction/output/lib
ln  -sf /usr/share/java/jboss4/jboss-transaction.jar .
popd

ant -f aspect-library-build.xml all

%endif
# -----------------------------------------------------------------------------

%install
rm -rf $RPM_BUILD_ROOT

install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}

# install aop framework
install -m 644 output-framework/lib/jboss-aop.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/jboss-aop-%{version}.jar
install -m 644 output-framework/lib/jdk14-pluggable-instrumentor.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/jdk14-pluggable-instrumentor-%{version}.jar
install -m 644 output-framework/lib/jboss-aop-jdk50.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/jboss-aop-jdk50-%{version}.jar
install -m 644 output-framework/lib/pluggable-instrumentor.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/pluggable-instrumentor-%{version}.jar

%if %{without_frameworkonly}

# install aspect library
install -m 644 output/lib/jboss-aspect-library.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/jboss-aspect-library-%{version}.jar
install -m 644 output/lib/jboss-aspect-library32.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/jboss-aspect-library32-%{version}.jar
install -m 644 output/lib/jboss-aspect-library-jdk50.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/jboss-aspect-library-jdk50-%{version}.jar
install -m 644 output/lib/jboss-aspect-library-jdk50-jb32.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/jboss-aspect-library-jdk50-jb32-%{version}.jar

%endif

# create all versionless symlinks
(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

%if %{without_frameworkonly}

# package home
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}

install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}/jboss-32-install
pushd $RPM_BUILD_ROOT%{_datadir}/%{name}/jboss-32-install
ln -sf %{_javadir}/gnu.trove.jar trove.jar
ln -sf %{_javadir}/javassist.jar javassist.jar
ln -sf %{_javadir}/jboss-aop/jboss-aop.jar jboss-aop.jar
ln -sf %{_javadir}/jboss-aop/jboss-aspect-library32.jar jboss-aspect-library32.jar
popd
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}/jboss-32-install-jdk5
pushd $RPM_BUILD_ROOT%{_datadir}/%{name}/jboss-32-install-jdk5
ln -sf %{_javadir}/gnu.trove.jar trove.jar
ln -sf %{_javadir}/javassist.jar javassist.jar
ln -sf %{_javadir}/jboss-aop/jboss-aop-jdk50.jar jboss-aop-jdk50.jar
ln -sf %{_javadir}/jboss-aop/jboss-aspect-library-jdk50-jb32.jar jboss-aspect-library-jdk50-jb32.jar
popd

install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}/jboss-40-install
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}/jboss-40-install/jboss-aop.deployer
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}/jboss-40-install/jboss-aop.deployer/META-INF
install -m 644 etc/base-aop.xml $RPM_BUILD_ROOT%{_datadir}/%{name}/jboss-40-install/jboss-aop.deployer
pushd $RPM_BUILD_ROOT%{_datadir}/%{name}/jboss-40-install/jboss-aop.deployer
ln -sf %{_javadir}/gnu.trove.jar trove.jar
ln -sf %{_javadir}/javassist.jar javassist.jar
ln -sf %{_javadir}/jboss-aop/jboss-aop.jar jboss-aop.jar
ln -sf %{_javadir}/jboss-aop/jboss-aspect-library.jar jboss-aspect-library.jar
popd
cp jboss-40-install/jboss-aop.deployer/META-INF/jboss-service.xml $RPM_BUILD_ROOT%{_datadir}/%{name}/jboss-40-install/jboss-aop.deployer/META-INF
cp jboss-40-install/jboss-aop.deployer/META-INF/MANIFEST.MF $RPM_BUILD_ROOT%{_datadir}/%{name}/jboss-40-install/jboss-aop.deployer/META-INF

install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}/jboss-40-install/jboss-aop-jdk50.deployer
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}/jboss-40-install/jboss-aop-jdk50.deployer/META-INF
install -m 644 etc/base-aop.xml $RPM_BUILD_ROOT%{_datadir}/%{name}/jboss-40-install/jboss-aop-jdk50.deployer
pushd $RPM_BUILD_ROOT%{_datadir}/%{name}/jboss-40-install/jboss-aop-jdk50.deployer
ln -sf %{_javadir}/gnu.trove.jar trove.jar
ln -sf %{_javadir}/javassist.jar javassist.jar
ln -sf %{_javadir}/jboss-aop/jboss-aop-jdk50.jar jboss-aop-jdk50.jar
ln -sf %{_javadir}/jboss-aop/jboss-aspect-library-jdk50.jar jboss-aspect-library-jdk50.jar
popd
cp jboss-40-install/jboss-aop-jdk50.deployer/META-INF/jboss-service.xml $RPM_BUILD_ROOT%{_datadir}/%{name}/jboss-40-install/jboss-aop-jdk50.deployer/META-INF
cp jboss-40-install/jboss-aop-jdk50.deployer/META-INF/MANIFEST.MF $RPM_BUILD_ROOT%{_datadir}/%{name}/jboss-40-install/jboss-aop-jdk50.deployer/META-INF

install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}/lib
pushd $RPM_BUILD_ROOT%{_datadir}/%{name}/lib
ln -sf %{_javadir}/bsh.jar bsh-1.3.0.jar
ln -sf %{_javadir}/concurrent.jar concurrent.jar
ln -sf %{_javadir}/javassist.jar javassist.jar
ln -sf %{_javadir}/qdox.jar qdox.jar
ln -sf %{_javadir}/gnu.trove.jar trove.jar
ln -sf %{_javadir}/jboss-aop/jboss-aop.jar jboss-aop.jar
ln -sf %{_javadir}/jboss-aop/jboss-aspect-library.jar jboss-aspect-library.jar
ln -sf %{_javadir}/jboss4/jboss-common.jar jboss-common.jar
ln -sf %{_javadir}/jboss-aop/jdk14-pluggable-instrumentor.jar jdk14-pluggable-instrumentor.jar
popd

install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}/lib-50
pushd $RPM_BUILD_ROOT%{_datadir}/%{name}/lib-50
ln -sf %{_javadir}/bsh.jar bsh-1.3.0.jar
ln -sf %{_javadir}/concurrent.jar concurrent.jar
ln -sf %{_javadir}/javassist.jar javassist.jar
ln -sf %{_javadir}/qdox.jar qdox.jar
ln -sf %{_javadir}/gnu.trove.jar trove.jar
ln -sf %{_javadir}/jboss-aop/jboss-aop-jdk50.jar jboss-aop-jdk50.jar
ln -sf %{_javadir}/jboss-aop/jboss-aspect-library-jdk50.jar jboss-aspect-library-jdk50.jar
ln -sf %{_javadir}/jboss4/jboss-common.jar jboss-common.jar
ln -sf %{_javadir}/jboss-aop/pluggable-instrumentor.jar pluggable-instrumentor.jar
popd

# bin
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}/bin
install -m 755 bin/*.sh $RPM_BUILD_ROOT%{_datadir}/%{name}/bin

# -----------------------------------------------------------------------------
# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/aspect-framework
cp -pr output-framework/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/aspect-framework
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/aspect-library
cp -pr output/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/aspect-library
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}

# -----------------------------------------------------------------------------
# manual
install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}
rm -rf docs/aspect-framework/api
cp -pr docs/aspect-framework/* $RPM_BUILD_ROOT%{_docdir}/%{name}
install -m 644 RELEASE_NOTES.html $RPM_BUILD_ROOT%{_docdir}/%{name}

%endif

%clean
rm -rf $RPM_BUILD_ROOT

# -----------------------------------------------------------------------------

%if %{without_frameworkonly}
%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
    rm -f %{_javadocdir}/%{name}
fi
%endif

# -----------------------------------------------------------------------------

%files framework
%defattr(0644,root,root,0755)
%{_javadir}/%{name}/jboss-aop-%{version}.jar
%{_javadir}/%{name}/jboss-aop.jar
%{_javadir}/%{name}/jdk14-pluggable-instrumentor-%{version}.jar
%{_javadir}/%{name}/jdk14-pluggable-instrumentor.jar
%{_javadir}/%{name}/jboss-aop-jdk50-%{version}.jar
%{_javadir}/%{name}/jboss-aop-jdk50.jar
%{_javadir}/%{name}/pluggable-instrumentor-%{version}.jar
%{_javadir}/%{name}/pluggable-instrumentor.jar

%if %{without_frameworkonly}
%files library
%defattr(0644,root,root,0755)
%{_javadir}/%{name}/jboss-aspect-library-%{version}.jar
%{_javadir}/%{name}/jboss-aspect-library.jar
%{_javadir}/%{name}/jboss-aspect-library32-%{version}.jar
%{_javadir}/%{name}/jboss-aspect-library32.jar
%{_javadir}/%{name}/jboss-aspect-library-jdk50-%{version}.jar
%{_javadir}/%{name}/jboss-aspect-library-jdk50.jar
%{_javadir}/%{name}/jboss-aspect-library-jdk50-jb32-%{version}.jar
%{_javadir}/%{name}/jboss-aspect-library-jdk50-jb32.jar

%{_datadir}/%{name}


%files javadoc
%defattr(0644,root,root,0755)
%doc %{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%files manual
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}

%endif

# -----------------------------------------------------------------------------

%changelog
* Wed Nov 16 2005 Ralph Apel <r.apel at r-apel.de> 0:1.3.1-2jpp
- Patch to qdox-1.5
* Fri Aug 05 2005 Ralph Apel <r.apel at r-apel.de> 0:1.3.1-1jpp
- First standalone release
- option '--with frameworkonly' to prepare for build of 
  jboss4-cache and jboss4-console
